;; Uses first extra bit: YES
;; Lower nybble of first extra byte determines the speed. (Wraps around at 4)
;; Upper nybble of first extra byte determines the colour. (Wraps around at 4)
;; Bit 6 of first extra byte determines whether it starts stationary or starts moving.
;; Extra bit determines the direction to start moving in.
;;
;; 0 : green  : normal speed	: stationary
;; 1 : yellow : double speed	: stationary
;; 2 : red    : fourfold speed	: stationary
;; 3 : blue   : sixfold speed	: stationary
;; 4 : green  : normal speed	: moving
;; 5 : yellow : double speed	: moving
;; 6 : red    : fourfold speed	: moving
;; 7 : blue   : sixfold speed	: moving
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

if !EXLEVEL
	!LayerLookUp		= $0BF6|!Base2			; 256 bytes of free RAM. Must be on shadow RAM.
	!L1_Lookup_Lo	= !LayerLookUp+96+96		; 32 bytes
	!L2_Lookup_Lo	= !LayerLookUp+96+96+16		; 16 bytes (shared)
	!L1_Lookup_Hi	= !LayerLookUp+96+96+32		; 32 bytes
	!L2_Lookup_Hi	= !LayerLookUp+96+96+32+16	; 16 bytes (shared)
endif

print "INIT ",pc
					LDA !extra_bits,x
					AND #$04
					BEQ +
					INC !157C,x
					+
					LDA !extra_byte_1,x
					AND #$02
					BNE RedINIT1
					LDA !extra_byte_1,x
					AND #$01
					BEQ GreenINIT1
					LDA #$05
					STA !1602,x
					BRA INIT2
GreenINIT1:
					LDA #$0B
					STA !1602,x
					BRA INIT2
RedINIT1:
					LDA !extra_byte_1,x
					AND #$01
					BNE BlueINIT1
					LDA #$09
					STA !1602,x
					BRA INIT2
BlueINIT1:
					LDA #$07
					STA !1602,x
INIT2:
					LDA !extra_byte_1,x
					AND #$20
					BNE RedINIT2
					LDA !extra_byte_1,x
					AND #$10
					BEQ GreenINIT2
					LDA #$05
					STA !1510,x
					BRA INIT3
GreenINIT2:
					LDA #$0B
					STA !1510,x
					BRA INIT3
RedINIT2:
					LDA !extra_byte_1,x
					AND #$10
					BNE BlueINIT2
					LDA #$09
					STA !1510,x
					BRA INIT3
BlueINIT2:
					LDA #$07
					STA !1510,x
INIT3:
					INC !1540,x
					PHB
					PHK
					PLB
					JSR MainCode
					JSR MainCode
					PLB
					LDA !extra_byte_1,x
					AND #$40
					BNE +
					INC !1626,x
					+
					RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

print "MAIN ",pc
HAMMER_BRO_JSL:
					PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR MainCode       ;  |
                    PLB                     ;  |
                    RTL                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine CODE_01DAA2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DeleteSprite:
					STZ !14C8,x
					LDY #$03                ; \ find a free slot to display effect
FINDFREE:
					LDA $17C0|!Base2,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open
FOUNDONE:
					LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0|!Base2,y             ; /
                    LDA !D8,x
                    STA $17C4|!Base2,y             ; /
                    LDA #$1B                ; \ set time to show smoke
                    STA $17CC|!Base2,y             ; /
                    LDA !E4,x
                    STA $17C8|!Base2,y             ; /
					RTS
MainCode:
					LDA !1588,x
					BNE DeleteSprite
					LDA !14E0,x
					BMI DeleteSprite
					LDA #$18
					STA $00
					LDA !E4,x
					PHA
					SEC
					SBC $00
					STA !E4,x
					LDA !14E0,x
					PHA
					SBC #$00
					STA !14E0,x
					LDA !D8,x
					PHA
					SEC
					SBC #$08
					STA !D8,x
					LDA !14D4,x
					PHA
					SBC #$00
					STA !14D4,x
					JSR DrawLiftGraphic
					PLA
					STA !14D4,x
					PLA
					STA !D8,x
					PLA
					STA !14E0,x
					PLA
					STA !E4,x
					LDA !E4,x
					PHA
					LDA #$01
					STA !1594,x
					LDA !14D4,x
					PHA
					LDA !D8,x
					PHA
					LDA !14E0,x
					PHA
					LDA !E4,x
					PHA
					JSR MoveLift
					LDA !1602,x
					CMP #$0B
					BEQ MoveFinish
					STZ !1594,x
					JSR MoveLift
					LDA !1602,x
					CMP #$05
					BEQ MoveFinish
					JSR MoveLift
					JSR MoveLift
					LDA !1602,x
					CMP #$09
					BEQ MoveFinish
					JSR MoveLift
					JSR MoveLift
MoveFinish:
					PLA
					SEC
					SBC !E4,x
					STA $0C
					PLA
					SBC !14E0,x
					STA $0D
					PLA
					SEC
					SBC !D8,x
					STA $0E
					PLA
					SBC !14D4,x
					STA $0F
					LDA !1504,x
					BEQ NotRide
					;LDA !1602,x
					;CMP #$0B
					;BEQ NotRide
					LDA !14D4,x
					CMP #$FF
					BEQ ChangeMarioPosition
					CMP #$1C
					BCS NotRide
ChangeMarioPosition:
					REP #$20
					LDA $96
					SEC
					SBC $0E
					STA $96
					SEP #$20
					JSR MarioJumpControll
NotRide:
					PLA
					SEC
					SBC !E4,x
					LDY !1528,x
					PHY
					EOR #$FF
					INC A
					STA !1528,x
					LDA #$18
					STA $00		;鉡
					LDA !E4,x
					PHA
					SEC
					SBC $00
					STA !E4,x
					LDA !14E0,x
					PHA
					SBC #$00
					STA !14E0,x
					LDA !D8,x
					PHA
					SEC
					SBC #$08
					STA !D8,x
					LDA !14D4,x
					PHA
					SBC #$00
					STA !14D4,x
					LDA !1504,x
					PHA
					STZ !1504,x
					JSL $01B44F	;悤ɂ
					PLA
					STA $0F
					BCC NotReset
					LDA $1471|!Base2
					STA !1504,x
					BEQ NotNowOnLift
					LDA $0F
					BNE NotNowOnLift
					STZ $7B
NotNowOnLift:
					LDA !1626,x
					BEQ NotReset
					STZ !1626,x
					STZ !1540,x
NotReset:
					PLA
					STA !14D4,x
					PLA
					STA !D8,x
					PLA
					STA !14E0,x
					PLA
					STA !E4,x
					PLA
					STA !1528,x
					RTS

					
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $01D74D Move Lift
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FlagTable:			db $80,$40,$20,$10,$08,$04,$02,$01

LiftXSpeed1:			db $00,$00,$30,$7F,$60,$18
LiftXSpeed2:			db $00,$00,$D0,$80,$A0,$E8
LiftYSpeed1:			db $00,$00,$20,$40,$30,$10
LiftYSpeed2:			db $00,$00,$B0,$A0,$A0,$C0

MoveLift:
					LDA #$01
					%SubOffScreen()
					LDA !1540,x
					BNE MoveLift2
					LDA $9D
					ORA !1626,x
					BNE Return001
MoveLift2:
					LDA !C2,x		;00:Î~ 01:ړ 02:
					BNE MoveLift2_1
					JSR SubMove1
Return001:
					RTS
MoveLift2_1:
					CMP #$01
					BNE MoveLift2_2
					JSR SubMove2
					RTS
MoveLift2_2:
					JSR SubMove3
					RTS
					

SubMove1XLow:		db $FC,$04,$FC,$04
SubMove1XHigh:		db $FF,$00,$FF,$00
SubMove1YLow:		db $FC,$FC,$04,$04
SubMove1YHigh:		db $FF,$FF,$00,$00

SubMove2:			;$01D768
					LDA $9D
					BNE Return791
					LDA !157C,x
					BNE Left791
					LDY !1534,x
					JSR Routine01D7B0
					INC !1534,x
					LDA !187B,x
					BEQ NotInc1534
					LDA $13
					LSR A
					BCC NotInc1534
					INC !1534,x
NotInc1534:
					LDA !1534,x
					CMP !1570,x
					BCC Return791
					STZ !C2,x
Return791:
					RTS
Left791:
					LDY !1570,x
					DEY
					JSR Routine01D7B0
					DEC !1570,x
					BEQ StzStatus
					LDA !187B,x
					BEQ Return7AF
					LDA $13
					LSR A
					BCC Return7AF
					DEC !1570,x
					BNE Return7AF
StzStatus:
					STZ !C2,x
Return7AF:
					RTS


SubMove1:			;$01D7F4 oO
					LDY #$03
SubMove1Loop:
					STY $1695|!Base2
					LDA !E4,x
					CLC
					ADC SubMove1XLow,y
					STA $02
					LDA !14E0,x
					ADC SubMove1XHigh,y
					STA $03
					LDA !D8,x
					CLC
					ADC SubMove1YLow,y
					STA $00
					LDA !14D4,x
					ADC SubMove1YHigh,y
					STA $01
					LDA !1540,x
					BNE SubCheckTile
					LDA $00
					AND #$F0
					STA $04
					LDA !D8,x
					AND #$F0
					CMP $04
					BNE SubCheckTile
					LDA $02
					AND #$F0
					STA $05
					LDA !E4,x
					AND #$F0
					CMP $05
					BEQ NotCheckTile	;WHighoCgςȂԂ̓^C`FbNȂ
SubCheckTile:
					JSR Routine01D94D
					BEQ NoLineEnd
LineEnd0:
					LDY !160E,x	;GĂ郌[16xԍ-76
					JMP LineEnd
NoLineEnd:
					LDA $1693|!Base2	;GĂubN
					CMP #$94	;ON/OFFXCb`ŏo鍶̋}ȃ[
					BEQ Tile94
					CMP #$95	;ON/OFFXCb`ŏoE̋}ȃ[
					BNE CheckTile
					LDA $14AF|!Base2	;ON/OFFXCb` 0̎95̓uNɂȂ
					BEQ NotCheckTile	;uN^C
					BNE CheckTile
Tile94:
					LDA $14AF|!Base2	;ON/OFFXCb` 1̎94̓uNɂȂ
					BNE NotCheckTile	;uN^C
CheckTile:
					LDA $1693|!Base2
					CMP #$76
					BCC NotCheckTile	;[^Cł͂Ȃ
					CMP #$9A
					BCC OnLailTile
NotCheckTile:
					LDY $1695|!Base2
					DEY
					BPL SubMove1Loop	;4`FbN郋[v
					LDA !C2,x			;00:Î~ 01:ړ 02:
					CMP #$02
					BEQ Return0139
					LDA #$02
					STA !C2,x
					LDY !160E,x	;GĂ郌[16xԍ-76
					LDA !157C,x			;direction
					BEQ GoRight
					TYA
					CLC
					ADC #$20
					TAY
GoRight:
					PHY
					PHX
					TYX
					LDA.l $01DD11,x
					PLX
					CMP #$00
					BEQ SetLiftYSpeed
					BMI MinusYSpeed
					LDA !1602,x
					LSR A
					TAY
					LDA LiftYSpeed1,y
					BRA SetLiftYSpeed
MinusYSpeed:
					LDA !1602,x
					LSR A
					TAY
					LDA LiftYSpeed2,y
SetLiftYSpeed:
					STA !AA,x
					PLY
					PHX
					TYX
					LDA.l $01DD51,x
					PLX
					ASL A
					BEQ SetLiftXSpeed
					BMI MinusXSpeed
					LDA !1602,x
					LSR A
					TAY
					LDA LiftXSpeed1,y
					BRA SetLiftXSpeed
MinusXSpeed:
					LDA !1602,x
					LSR A
					TAY
					LDA LiftXSpeed2,y
SetLiftXSpeed:
					STA !B6,x
					LDA #$10
					STA !1540,x
Return0139:
					RTS
OnLailTile:
					PHA
					SEC
					SBC #$76
					TAY
					PLA
					CMP #$96
					BCC NotLineEnd
					JMP LineEnd0
NotLineEnd:
					LDA !D8,x
					STA $08
					LDA !14D4,x
					STA $09
					LDA !E4,x
					STA $0A
					LDA !14E0,x
					STA $0B
					LDA $00
					STA !D8,x
					LDA $01
					STA !14D4,x
					LDA $02
					STA !E4,x
					LDA $03
					STA !14E0,x
LineEnd:
					PHB
					LDA #$07	;->DataBankRegister
					PHA
					PLB
					LDA $FBF3,y	;$07FBF3,y ;Y:[̃^C̎
					STA !151C,x
					LDA $FC13,y	;$07FC13,y ;Y:[̃^C̎
					STA !1528,x
					PLB			;back DataBank
					PHX
					TYX
					LDA.l $01DCD1,x
					PLX
					STA !1570,x
					STZ !1534,x
					TYA
					STA !160E,x	;GĂ郌[16xԍ-76
					LDA !1540,x
					BNE ChangeStatus
					STZ !157C,x	;GoLeft
					PHX
					TYX
					LDA.l $01DCF1,x
					PLX
					CMP #$00
					BEQ MoveHorz
					TAY
					LDA !D8,x
					CPY #$01	;Y01YW̉4bit𔽓]A
					BNE NotBitRev
					EOR #$0F
NotBitRev:
					BRA MoveVert
MoveHorz:
					LDA !E4,x
MoveVert:
					AND #$0F
					CMP #$0A
					BCC NotTurnDir
					LDA !C2,x
					CMP #$02
					BEQ NotTurnDir
					INC !157C,x
NotTurnDir:
					LDA !D8,x
					STA $0C
					LDA !E4,x
					STA $0D
					JSR SubMove2
					LDA $0C
					SEC
					SBC !D8,x
					CLC
					ADC #$08
					CMP #$10
					BCS MoveHorz_2
					LDA $0D
					SEC
					SBC !E4,x
					CLC
					ADC #$08
					CMP #$10
					BCS MoveHorz_2
ChangeStatus:
					LDA #$01
					STA !C2,x
					RTS
MoveHorz_2:
					LDA $08
					STA !D8,x
					LDA $09
					STA !14D4,x
					LDA $0A
					STA !E4,x
					LDA $0B
					STA !14E0,x
					JMP NotCheckTile
					

Routine01D94D:
					LDA $00
					AND #$F0
					STA $06
					LDA $02
					LSR A
					LSR A
					LSR A
					LSR A
					PHA
					ORA $06
					PHA
					LDA $5B	;0:}bv 1:c}bv
					AND #$01
					BEQ HorzMAP
					PLA
					LDX $01
					CLC
					ADC.l $00BA80,x
					STA $05
					LDA.l $00BABC,x
					ADC $03
					STA $06
					BRA VertMAP
HorzMAP:
					PLA
					LDX $03
					CLC
if !EXLEVEL
	ADC.L !L1_Lookup_Lo,x
else
    ADC.l $00BA60|!BankB,X      ;$01D97B    || Get tile pointer (horizontal level).
endif
    STA $05                     ;$01D97F    ||
if !EXLEVEL
	LDA.L !L1_Lookup_Hi,x
else
    LDA.l $00BA9C|!BankB,X      ;$01D981    ||
endif
    ADC $01                     ;$01D985    ||
    STA $06                     ;$01D987    |/
VertMAP:
if !SA1
	LDA #$40		            ; bank byte of pointer to tile low byte = $7E
else
	LDA #$7E		            ; bank byte of pointer to tile low byte = $7E
endif
					STA $07
					LDX $15E9|!Base2
					LDA [$05]
					STA $1693|!Base2
					INC $07
					LDA [$05]
					PLY
					STY $05
					PHA
					LDA $05
					AND #$07
					TAY
					PLA
					AND FlagTable,y
					RTS
					
SubMove3:			;$01DB44
					LDA $9D
					BNE ReturnB59
					LDA !1594,x
					BEQ NotAirMove
					JSL $01802A	;move sprite by AA and B6
NotAirMove:
					LDA !1540,x
					BNE ReturnB59
					LDA !AA,x
					CMP #$20
					BMI ReturnB59
					JSR SubMove1
ReturnB59:
					RTS

Routine01D7B0:
					PHB
					LDA #$07
					PHA
					PLB
					LDA !151C,x	;xx
					STA $04
					LDA !1528,x	;yy
					STA $05
					LDA ($04),y	;$07yyxx,y
					AND #$0F
					STA $06
					LDA ($04),y
					PLB
					LSR A
					LSR A
					LSR A
					LSR A
					STA $07
					LDA !D8,x
					AND #$F0
					CLC
					ADC $07
					STA !D8,x
					LDA !E4,x
					AND #$F0
					CLC
					ADC $06
					STA !E4,x
					RTS
					


					
					
MarioJumpControll:
					LDA $7D
					BPL ReturnJump
					LDA !C2,x
					CMP #$02
					BNE LiftIsOnLine
					LDA !AA,x
					BCC SkipMarioFall
					LDA $7D
					CLC
					ADC !AA,x
					STA $7D
					BMI SkipMarioFall
					LDA #$80
					STA $7D
SkipMarioFall:
					LDA $7B
					BMI JumpLeft
					LDA $7B
					CLC
					ADC !B6,x
					STA $7B
					LDA !B6,x
					BMI ReturnJump
					LDA $7B
					BPL ReturnJump
					LDA #$7F
					STA $7B
					RTS
JumpLeft:
					LDA $7B
					CLC
					ADC !B6,x
					STA $7B
					LDA !B6,x
					BPL ReturnJump
					LDA $7B
					BMI ReturnJump
					LDA #$80
					STA $7B
ReturnJump:
					RTS
LiftIsOnLine:
					REP #$20
					LDA $0E
					BMI SkipMarioFall2
					ASL A
					ASL A
					ASL A
					ASL A
					EOR.W #$FFFF
					INC A
					SEP #$20
					CLC
					ADC $7D
					STA $7D
					BMI SkipMarioFall2
					LDA #$80
					STA $7D
SkipMarioFall2:
					REP #$20
					LDA $0C
					ASL A
					ASL A
					ASL A
					ASL A
					EOR.W #$FFFF
					INC A
					STA $0C
					SEP #$20
					LDA $7B
					BMI JumpLeft2
					LDA $7B
					CLC
					ADC $0C
					STA $7B
					LDA $0C
					BMI ReturnJump2
					LDA $7B
					BPL ReturnJump2
					LDA #$7F
					STA $7B
					RTS
JumpLeft2:
					LDA $7B
					CLC
					ADC $0C
					STA $7B
					LDA $0C
					BPL ReturnJump2
					LDA $7B
					BMI ReturnJump2
					LDA #$80
					STA $7B
ReturnJump2:
					RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DrawLiftGraphic:
					%GetDrawInfo()
                    LDA !1510,x	;0B:΃tg 05:Ftg 09:ԃtg
					STA $01
					LDA !D8,x
					SEC
					SBC $1C
					STA $0301|!Base2,y
					STA $0305|!Base2,y
					STA $0309|!Base2,y
					LDA !E4,x
					SEC
					SBC $1A
					STA $0300|!Base2,y
					CLC
					ADC #$10
					STA $0304|!Base2,y
					CLC
					ADC #$10
					STA $0308|!Base2,y

					LDA #$60
					STA $0302|!Base2,y
					LDA #$61
					STA $0306|!Base2,y
					LDA #$62
					STA $030A|!Base2,y
					
					LDA $64
					ORA !1510,x
					STA $0303|!Base2,y
					STA $0307|!Base2,y
					STA $030B|!Base2,y
					LDA #$02
					LDY #$02
					JSL $01B7B3
					RTS

